"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var path_1 = require("path");
var fs_1 = require("fs");
var glob = require("glob");
var output_1 = require("../../common/output");
var common_1 = require("../../common/common");
function copyMul(src, dest) {
    var dir = [];
    for (var _i = 2; _i < arguments.length; _i++) {
        dir[_i - 2] = arguments[_i];
    }
    return __awaiter(this, void 0, void 0, function () {
        var i;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!dir.length) return [3, 7];
                    return [4, copyRf(src, dir[dir.length - 1])];
                case 1:
                    _a.sent();
                    return [4, copyRf(dest, dir[dir.length - 1])];
                case 2:
                    _a.sent();
                    i = 0;
                    _a.label = 3;
                case 3:
                    if (!(i <= dir.length - 2)) return [3, 6];
                    return [4, copyRf(dir[i], dir[dir.length - 1])];
                case 4:
                    _a.sent();
                    _a.label = 5;
                case 5:
                    i++;
                    return [3, 3];
                case 6: return [3, 9];
                case 7: return [4, copyRf(src, dest)];
                case 8:
                    _a.sent();
                    _a.label = 9;
                case 9: return [2];
            }
        });
    });
}
exports.copyMul = copyMul;
function copyRf(src, dest) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    src = path_1.resolve(src);
                    dest = path_1.resolve(dest);
                    if (!fs_1.existsSync(dest)) {
                        fs_1.mkdirSync(dest);
                    }
                    return [4, copyGlob(src, dest)];
                case 1:
                    _a.sent();
                    return [2];
            }
        });
    });
}
exports.copyRf = copyRf;
function copyGlob(src, dest) {
    return __awaiter(this, void 0, void 0, function () {
        var _this = this;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, new Promise(function (res, rej) {
                        src = path_1.resolve(src);
                        dest = path_1.resolve(dest);
                        glob(src, function (err, matches) { return __awaiter(_this, void 0, void 0, function () {
                            var _loop_1, _i, matches_1, n;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0:
                                        _loop_1 = function (n) {
                                            return __generator(this, function (_a) {
                                                switch (_a.label) {
                                                    case 0: return [4, new Promise(function (res1, rej1) {
                                                            fs_1.stat(n, function (err, stats) {
                                                                var copyDest = common_1.getFileTo(n, getGlobBase(src), dest);
                                                                output_1.log('copy:', n, 'to', copyDest);
                                                                if (stats.isDirectory()) {
                                                                    if (!fs_1.existsSync(copyDest)) {
                                                                        fs_1.mkdirSync(copyDest);
                                                                    }
                                                                    res1();
                                                                }
                                                                else {
                                                                    fs_1.createReadStream(n)
                                                                        .pipe(fs_1.createWriteStream(copyDest))
                                                                        .on('close', function () {
                                                                        res1();
                                                                    });
                                                                }
                                                            });
                                                        })];
                                                    case 1:
                                                        _a.sent();
                                                        return [2];
                                                }
                                            });
                                        };
                                        _i = 0, matches_1 = matches;
                                        _a.label = 1;
                                    case 1:
                                        if (!(_i < matches_1.length)) return [3, 4];
                                        n = matches_1[_i];
                                        return [5, _loop_1(n)];
                                    case 2:
                                        _a.sent();
                                        _a.label = 3;
                                    case 3:
                                        _i++;
                                        return [3, 1];
                                    case 4:
                                        res();
                                        return [2];
                                }
                            });
                        }); });
                    })];
                case 1:
                    _a.sent();
                    return [2];
            }
        });
    });
}
exports.copyGlob = copyGlob;
function makeDirRecursive(path) {
    var dir = path_1.dirname(path);
    if (!fs_1.existsSync(dir)) {
        makeDirRecursive(dir);
        fs_1.mkdirSync(dir);
    }
}
exports.makeDirRecursive = makeDirRecursive;
function getGlobBase(pattern) {
    if (!glob.hasMagic(pattern)) {
        throw new Error('not Glob pattern');
    }
    if (!pattern.length) {
        throw new Error('pattern could not be empty');
    }
    var arr = pattern.split(path_1.sep), base = arr.shift() || '';
    for (var _i = 0, arr_1 = arr; _i < arr_1.length; _i++) {
        var n = arr_1[_i];
        if (n.match(/\*/)) {
            break;
        }
        else {
            base += path_1.sep + n;
        }
    }
    return base;
}
exports.getGlobBase = getGlobBase;
function rmGlob(dir) {
    return __awaiter(this, void 0, void 0, function () {
        var _this = this;
        return __generator(this, function (_a) {
            return [2, new Promise(function (res, rej) {
                    output_1.log('starting rm dir:', dir);
                    glob(dir, function (err, matches) { return __awaiter(_this, void 0, void 0, function () {
                        var _loop_2, _i, _a, n;
                        return __generator(this, function (_b) {
                            switch (_b.label) {
                                case 0:
                                    if (err) {
                                        output_1.log(err);
                                        rej();
                                    }
                                    _loop_2 = function (n) {
                                        return __generator(this, function (_a) {
                                            switch (_a.label) {
                                                case 0:
                                                    output_1.log('rm:', n);
                                                    return [4, new Promise(function (res1, rej1) {
                                                            fs_1.stat(n, function (err, stats) {
                                                                if (stats.isDirectory()) {
                                                                    fs_1.rmdirSync(n);
                                                                }
                                                                else {
                                                                    fs_1.unlinkSync(n);
                                                                }
                                                                res1();
                                                            });
                                                        })];
                                                case 1:
                                                    _a.sent();
                                                    return [2];
                                            }
                                        });
                                    };
                                    _i = 0, _a = matches.reverse();
                                    _b.label = 1;
                                case 1:
                                    if (!(_i < _a.length)) return [3, 4];
                                    n = _a[_i];
                                    return [5, _loop_2(n)];
                                case 2:
                                    _b.sent();
                                    _b.label = 3;
                                case 3:
                                    _i++;
                                    return [3, 1];
                                case 4:
                                    res();
                                    return [2];
                            }
                        });
                    }); });
                })];
        });
    });
}
exports.rmGlob = rmGlob;
function rmRf(dir) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, rmGlob(dir + '/**')];
                case 1:
                    _a.sent();
                    return [2];
            }
        });
    });
}
exports.rmRf = rmRf;
//# sourceMappingURL=fs.js.map