"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs_1 = require("fs");
var path_1 = require("path");
var postcss = require("postcss");
var chokidar = require("chokidar");
var fs_2 = require("./fs");
var cssnext = require("postcss-cssnext");
var output_1 = require("../../common/output");
function pcss(_a) {
    var watch = _a.watch, file = _a.file, dir = _a.dir;
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!watch) return [3, 1];
                    dir = watch;
                    output_1.log('watching pcss file ' + dir);
                    dir = path_1.resolve(dir, '**/*.pcss');
                    chokidar.watch(dir)
                        .on('change', function (p) {
                        return __awaiter(this, void 0, void 0, function () {
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0: return [4, parseCss(p)];
                                    case 1:
                                        _a.sent();
                                        return [2];
                                }
                            });
                        });
                    });
                    return [3, 5];
                case 1:
                    if (!file) return [3, 3];
                    dir = file;
                    dir = path_1.resolve(dir);
                    return [4, parseCss(dir)];
                case 2:
                    _a.sent();
                    return [3, 5];
                case 3:
                    if (!dir) return [3, 5];
                    return [4, parseCss(dir)];
                case 4:
                    _a.sent();
                    _a.label = 5;
                case 5: return [2];
            }
        });
    });
}
exports.pcss = pcss;
function parseCss(fileFrom, dirTo) {
    return __awaiter(this, void 0, void 0, function () {
        var fileName, destDir, destFile;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    fileName = path_1.basename(fileFrom, '.pcss'), destDir = dirTo ? dirTo : path_1.dirname(fileFrom), destFile = path_1.resolve(destDir, fileName + '.css');
                    return [4, new Promise(function (res, rej) {
                            fs_1.stat(destDir, function (err, stats) {
                                if (err) {
                                    fs_2.makeDirRecursive(destFile);
                                }
                                else if (!stats.isDirectory()) {
                                    throw new Error('filePath is not a directory');
                                }
                                res();
                            });
                        })];
                case 1:
                    _a.sent();
                    output_1.log('parsing pcss file "' + fileFrom + '" ...');
                    return [4, new Promise(function (res, rej) {
                            fs_1.readFile(fileFrom, function (err, css) {
                                if (err)
                                    rej();
                                postcss([cssnext])
                                    .process(css, {
                                    from: fileFrom,
                                    to: destFile
                                })
                                    .then(function (result) {
                                    fs_1.writeFileSync(destFile, result.css);
                                    if (result.map)
                                        fs_1.writeFileSync(path_1.resolve(destDir, fileName + '.css.map'), result.map);
                                    output_1.log('parsing pcss file success!');
                                    res();
                                });
                            });
                        })];
                case 2:
                    _a.sent();
                    return [2];
            }
        });
    });
}
exports.parseCss = parseCss;
//# sourceMappingURL=pcss.js.map