"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var path_1 = require("path");
var fs_1 = require("fs");
var dirFromDef = 'src', dirToDef = 'built';
function cmdName(name) {
    if (process.platform === 'win32') {
        return name + '.cmd';
    }
    return name;
}
exports.cmdName = cmdName;
function editJsonFile(filePath, key, value) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            return [2, new Promise(function (res, rej) {
                    if (!path_1.isAbsolute(filePath)) {
                        throw new Error('filePath is not absolute path!');
                    }
                    var tsconfig, data;
                    try {
                        tsconfig = require(filePath);
                        data = tsconfig;
                    }
                    catch (error) {
                        throw error;
                    }
                    for (var _i = 0, key_1 = key; _i < key_1.length; _i++) {
                        var n = key_1[_i];
                        if (key.lastIndexOf(n) === key.length - 1) {
                            data[n] = value;
                        }
                        data = data[n];
                    }
                    fs_1.writeFile(filePath, JSON.stringify(tsconfig, null, 4), function (err) {
                        res();
                    });
                })];
        });
    });
}
exports.editJsonFile = editJsonFile;
function getFileTo(fileFrom, dirFrom, dirTo, ext) {
    if (!fileFrom.match(dirFrom)) {
        throw new Error('file is not in the directory');
    }
    var result = path_1.resolve(dirTo, path_1.relative(dirFrom, fileFrom));
    if (ext) {
        var obj = path_1.parse(result);
        obj.ext = ext;
        delete obj.base;
        result = path_1.format(obj);
    }
    return result;
}
exports.getFileTo = getFileTo;
function getDirFrom(dirFrom) {
    return path_1.resolve(dirFrom || process.env.npm_package_config_product_from || dirFromDef);
}
exports.getDirFrom = getDirFrom;
function getDirTo(dirTo) {
    return path_1.resolve(dirTo || process.env.npm_package_config_product_to || dirToDef);
}
exports.getDirTo = getDirTo;
//# sourceMappingURL=common.js.map