"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var path_1 = require("path");
function log() {
    var str = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        str[_i] = arguments[_i];
    }
    console.log.apply(console, [getCallerFileName() + ':'].concat(str));
}
exports.log = log;
function getCallerFileName() {
    var stack = new Error().stack, stackArr, fileNameArr = [];
    if (stack) {
        stackArr = stack.split('\n');
        for (var _i = 0, stackArr_1 = stackArr; _i < stackArr_1.length; _i++) {
            var n = stackArr_1[_i];
            var path = getPathFromStack(n);
            path && fileNameArr.push(path_1.basename(path));
            if (fileNameArr.length > 1) {
                if (fileNameArr[fileNameArr.length - 1] !== fileNameArr[0])
                    return fileNameArr[fileNameArr.length - 1];
            }
        }
    }
}
exports.getCallerFileName = getCallerFileName;
function getPathFromStack(path) {
    var r = /\((.*):\d+:\d/.exec(path);
    if (r && r.length > 1) {
        return r[1];
    }
    else {
        return '';
    }
}
exports.getPathFromStack = getPathFromStack;
//# sourceMappingURL=output.js.map