"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var path_1 = require("path");
var fs_1 = require("fs");
var mime_1 = require("mime");
function getContentType(filePath) {
    var ext = path_1.parse(filePath).ext;
    return mime_1.getType(ext);
}
exports.getContentType = getContentType;
function setHeaderContentType(res, filePath) {
    var contentType = getContentType(filePath);
    if (contentType) {
        res.setHeader('Content-Type', contentType);
    }
}
exports.setHeaderContentType = setHeaderContentType;
function setHeaderContentLength(res, filePath) {
    var size = fs_1.statSync(filePath).size;
    res.setHeader('Content-Length', size);
}
exports.setHeaderContentLength = setHeaderContentLength;
function setHeaderETag(res) {
    res.setHeader('ETag', "hwGsXizcT76zd05rupUiKxVtUsI=");
}
exports.setHeaderETag = setHeaderETag;
//# sourceMappingURL=header.js.map