"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var stream_1 = require("stream");
var fs_1 = require("fs");
var inject_1 = require("../inject/inject");
var header_1 = require("./header");
var r500_1 = require("./r500");
var R200 = (function (_super) {
    __extends(R200, _super);
    function R200(res, filePath, options) {
        var _this = _super.call(this, options) || this;
        _this.res = res;
        header_1.setHeaderContentType(res, filePath);
        header_1.setHeaderETag(res);
        return _this;
    }
    R200.prototype._write = function (chunk, encoding, callback) {
        this.res.write(chunk, callback);
    };
    R200.prototype._final = function (callback) {
        this.res.end(null, callback);
    };
    return R200;
}(stream_1.Writable));
function res200(res, filePath) {
    var r200 = new R200(res, filePath);
    if (header_1.getContentType(filePath) === 'text/html') {
        var data = fs_1.readFileSync(filePath, 'utf8');
        data = inject_1.inject(data);
        res.setHeader('Content-Length', data.length);
        r200.end(data);
    }
    else {
        header_1.setHeaderContentLength(res, filePath);
        fs_1.createReadStream(filePath)
            .on('error', function (err) {
            r500_1.r500(res, err);
        })
            .pipe(r200);
    }
}
exports.res200 = res200;
//# sourceMappingURL=r200.js.map