"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var http_1 = require("http");
var WebSocket = require("ws");
var file_1 = require("./file/file");
var output_1 = require("../common/output");
function server(dir, port) {
    output_1.log('starting server at', dir);
    http_1.createServer(function (req, res) {
        output_1.log("http: " + req.method + " " + req.url);
        file_1.doFile(req, res, dir);
    }).listen(+port);
    var wss = new WebSocket.Server({ port: 19009 });
    wss.on('connection', function connection(ws) {
        output_1.log('web socket connected');
        file_1.watchFileChange(ws, dir);
    });
}
exports.server = server;
//# sourceMappingURL=server.js.map